aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--plugins/README.md1
-rwxr-xr-xplugins/mp3conv34
2 files changed, 35 insertions, 0 deletions
diff --git a/plugins/README.md b/plugins/README.md
index f1401e2..1b327ff 100644
--- a/plugins/README.md
+++ b/plugins/README.md
@@ -48,6 +48,7 @@ Plugins are installed to `${XDG_CONFIG_HOME:-$HOME/.config}/nnn/plugins`.
| mediainf | Show media information | sh | mediainfo |
| moclyrics | Show lyrics of the track playing in moc | sh | [ddgr](https://github.com/jarun/ddgr), [moc](http://moc.daper.net/) |
| mocplay | Append (and/or play) selection/dir/file in moc | sh | [moc](http://moc.daper.net/) |
+| mp3conv | Extract audio from multimedia as mp3 | sh | ffmpeg |
| nmount | Toggle mount status of a device as normal user | sh | pmount, udisks2 |
| nuke | Sample file opener (CLI-only by default) | sh | various |
| oldbigfile | List large files by access time | sh | find, sort |
diff --git a/plugins/mp3conv b/plugins/mp3conv
new file mode 100755
index 0000000..b60b891
--- /dev/null
+++ b/plugins/mp3conv
@@ -0,0 +1,34 @@
+#!/usr/bin/env sh
+
+# Description: Extract audio from multimedia files and convert to mp3
+#
+# Dependency: ffmpeg compiled with libmp3lame audio codec support
+#
+# Shell: POSIX compliant
+# Author: Arun Prakash Jana
+
+outdir=_mp3files
+
+if ! [ -e "${outdir}" ]; then
+ mkdir "${outdir}"
+fi
+
+handle_multimedia() {
+ mime="${1}"
+ file="${2}"
+
+ case "${mime}" in
+ audio/* | video/*)
+ ffmpeg -i "${file}" -vn -codec:a libmp3lame -q:a 2 "${outdir}"/"${file%.*}.mp3"
+ ;;
+ *)
+ ;;
+ esac
+}
+
+for f in *; do
+ if [ -f "${f}" ]; then
+ mimestr="$( file --dereference --brief --mime-type -- "${f}" )"
+ handle_multimedia "${mimestr}" "${f}"
+ fi
+done